<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:dsp="urn:aria-raps:etl-dsp-sales:1.0" xmlns:iso="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-UpTake-Type-1.0" xmlns:sch="http://www.ascc.net/xml/schematron" xmlns:vals="urn:ARIA-UpTake-Validators-1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" dsp:dummy-for-xmlns="" rapstype:dummy-for-xmlns="" vals:dummy-for-xmlns="" version="1.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
<xsl:param name="archiveDirParameter"/><xsl:param name="archiveNameParameter"/><xsl:param name="fileNameParameter"/><xsl:param name="fileDirParameter"/>

<!--PHASES-->


<!--PROLOG-->
<xsl:output xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" method="xml" omit-xml-declaration="no" standalone="yes" indent="yes"/>

<!--KEYS-->


<!--DEFAULT RULES-->


<!--MODE: SCHEMATRON-SELECT-FULL-PATH-->
<!--This mode can be used to generate an ugly though full XPath for locators-->
<xsl:template match="*" mode="schematron-select-full-path">
		<xsl:apply-templates select="." mode="schematron-get-full-path"/>
	</xsl:template>

<!--MODE: SCHEMATRON-FULL-PATH-->
<!--This mode can be used to generate an ugly though full XPath for locators-->
<xsl:template match="*" mode="schematron-get-full-path">
		<xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
		<xsl:text>/</xsl:text>
		<xsl:choose>
			<xsl:when test="namespace-uri()=''">
				<xsl:value-of select="name()"/>
				<xsl:variable name="p_1" select="1+    count(preceding-sibling::*[name()=name(current())])"/>
				<xsl:if test="$p_1&gt;1 or following-sibling::*[name()=name(current())]">[<xsl:value-of select="$p_1"/>]</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>*[local-name()='</xsl:text>
				<xsl:value-of select="local-name()"/>
				<xsl:text>' and namespace-uri()='</xsl:text>
				<xsl:value-of select="namespace-uri()"/>
				<xsl:text>']</xsl:text>
				<xsl:variable name="p_2" select="1+   count(preceding-sibling::*[local-name()=local-name(current())])"/>
				<xsl:if test="$p_2&gt;1 or following-sibling::*[local-name()=local-name(current())]">[<xsl:value-of select="$p_2"/>]</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template><xsl:template match="@*" mode="schematron-get-full-path">
		<xsl:text>/</xsl:text>
		<xsl:choose>
			<xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/></xsl:when>
			<xsl:otherwise>
				<xsl:text>@*[local-name()='</xsl:text>
				<xsl:value-of select="local-name()"/>
				<xsl:text>' and namespace-uri()='</xsl:text>
				<xsl:value-of select="namespace-uri()"/>
				<xsl:text>']</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

<!--MODE: SCHEMATRON-FULL-PATH-2-->
<!--This mode can be used to generate prefixed XPath for humans-->
<xsl:template match="node() | @*" mode="schematron-get-full-path-2">
		<xsl:for-each select="ancestor-or-self::*">
			<xsl:text>/</xsl:text>
			<xsl:value-of select="name(.)"/>
			<xsl:if test="preceding-sibling::*[name(.)=name(current())]">
				<xsl:text>[</xsl:text>
				<xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
				<xsl:text>]</xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:if test="not(self::*)"><xsl:text/>/@<xsl:value-of select="name(.)"/></xsl:if>
	</xsl:template>

<!--MODE: GENERATE-ID-FROM-PATH -->
<xsl:template match="/" mode="generate-id-from-path"/><xsl:template match="text()" mode="generate-id-from-path">
		<xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
		<xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
	</xsl:template><xsl:template match="comment()" mode="generate-id-from-path">
		<xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
		<xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
	</xsl:template><xsl:template match="processing-instruction()" mode="generate-id-from-path">
		<xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
		<xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
	</xsl:template><xsl:template match="@*" mode="generate-id-from-path">
		<xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
		<xsl:value-of select="concat('.@', name())"/>
	</xsl:template><xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
		<xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
		<xsl:text>.</xsl:text>
		<xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
	</xsl:template><!--MODE: SCHEMATRON-FULL-PATH-3-->
<!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
<xsl:template match="node() | @*" mode="schematron-get-full-path-3">
		<xsl:for-each select="ancestor-or-self::*">
			<xsl:text>/</xsl:text>
			<xsl:value-of select="name(.)"/>
			<xsl:if test="parent::*">
				<xsl:text>[</xsl:text>
				<xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
				<xsl:text>]</xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:if test="not(self::*)"><xsl:text/>/@<xsl:value-of select="name(.)"/></xsl:if>
	</xsl:template>

<!--MODE: GENERATE-ID-2 -->
<xsl:template match="/" mode="generate-id-2">U</xsl:template><xsl:template match="*" mode="generate-id-2" priority="2">
		<xsl:text>U</xsl:text>
		<xsl:number level="multiple" count="*"/>
	</xsl:template><xsl:template match="node()" mode="generate-id-2">
		<xsl:text>U.</xsl:text>
		<xsl:number level="multiple" count="*"/>
		<xsl:text>n</xsl:text>
		<xsl:number count="node()"/>
	</xsl:template><xsl:template match="@*" mode="generate-id-2">
		<xsl:text>U.</xsl:text>
		<xsl:number level="multiple" count="*"/>
		<xsl:text>_</xsl:text>
		<xsl:value-of select="string-length(local-name(.))"/>
		<xsl:text>_</xsl:text>
		<xsl:value-of select="translate(name(),':','.')"/>
	</xsl:template><!--Strip characters--><xsl:template match="text()" priority="-1"/>

<!--SCHEMA METADATA-->
<xsl:template match="/">
		<svrl:schematron-output xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" title="ARIA-ETL-DSP schematron file. Validates required reliationships within an DSP Sales File." schemaVersion="ISO19757-3">
			<xsl:comment><xsl:value-of select="$archiveDirParameter"/>   
		 <xsl:value-of select="$archiveNameParameter"/>  
		 <xsl:value-of select="$fileNameParameter"/>  
		 <xsl:value-of select="$fileDirParameter"/></xsl:comment>
			<svrl:ns-prefix-in-attribute-values uri="urn:aria-raps:etl-dsp-sales:1.0" prefix="dsp"/>
			<svrl:ns-prefix-in-attribute-values uri="urn:ARIA-UpTake-Type-1.0" prefix="rapstype"/>
			<svrl:ns-prefix-in-attribute-values uri="urn:ARIA-UpTake-Validators-1.0" prefix="vals"/>
			<svrl:ns-prefix-in-attribute-values uri="http://www.w3.org/1999/XSL/Transform" prefix="xsl"/>
			<svrl:active-pattern>
				<xsl:attribute name="id">provider.checks</xsl:attribute>
				<xsl:attribute name="name">Global validation of common items within the file.</xsl:attribute>
				<xsl:apply-templates/>
			</svrl:active-pattern>
			<xsl:apply-templates select="/" mode="M5"/>
			<svrl:active-pattern>
				<xsl:attribute name="id">tracksale.checks</xsl:attribute>
				<xsl:attribute name="name">Track ISRCs are validated against embedded function</xsl:attribute>
				<xsl:apply-templates/>
			</svrl:active-pattern>
			<xsl:apply-templates select="/" mode="M6"/>
			<svrl:active-pattern>
				<xsl:attribute name="id">trackplay.checks</xsl:attribute>
				<xsl:attribute name="name">Track Play ISRCs are validated against embedded function</xsl:attribute>
				<xsl:apply-templates/>
			</svrl:active-pattern>
			<xsl:apply-templates select="/" mode="M7"/>
			<svrl:active-pattern>
				<xsl:attribute name="id">bundlesale.checks</xsl:attribute>
				<xsl:attribute name="name">Bundle Validations</xsl:attribute>
				<xsl:apply-templates/>
			</svrl:active-pattern>
			<xsl:apply-templates select="/" mode="M8"/>
		</svrl:schematron-output>
	</xsl:template>

<!--SCHEMATRON PATTERNS-->
<svrl:text xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema">ARIA-ETL-DSP schematron file. Validates required reliationships within an DSP Sales File.</svrl:text>

<!--PATTERN provider.checksGlobal validation of common items within the file.-->
<svrl:text xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema">Global validation of common items within the file.</svrl:text>

	<!--RULE -->
<xsl:template match="dsp:Provider" priority="1000" mode="M5"><svrl:fired-rule xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" context="dsp:Provider"/>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="(count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and (not(@Retailer) or @Retailer='')]) = 0 and count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and @Retailer])  &gt; 0) or (count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and (not(@Retailer) or @Retailer='')]) &gt; 0 and count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and @Retailer]) = 0)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="(count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and (not(@Retailer) or @Retailer='')]) = 0 and count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and @Retailer]) &gt; 0) or (count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and (not(@Retailer) or @Retailer='')]) &gt; 0 and count(//*[(name()='TrackSale' or name()='TrackPlay' or name()='BundleSale') and @Retailer]) = 0)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="provider.invalid.AmbiguousRetailerUsage.diag">
The file contains mixed usage of the Retailer attribute. The Retailer is optional, however, it may only be ommited when there is 1 retailer. If multiple reatailers are reported within the single file, then all sales must have a qualifying Retailer set.</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose><xsl:apply-templates select="*|comment()|processing-instruction()" mode="M5"/></xsl:template><xsl:template match="text()" priority="-1" mode="M5"/><xsl:template match="@*|node()" priority="-2" mode="M5">
		<xsl:apply-templates select="*|comment()|processing-instruction()" mode="M5"/>
	</xsl:template>

<!--PATTERN tracksale.checksTrack ISRCs are validated against embedded function-->
<svrl:text xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema">Track ISRCs are validated against embedded function</svrl:text>

	<!--RULE -->
<xsl:template match="dsp:TrackSale" priority="1000" mode="M6"><svrl:fired-rule xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" context="dsp:TrackSale"/>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@ISRC) or vals:ValidateISRC(@ISRC)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@ISRC) or vals:ValidateISRC(@ISRC)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.ISRC.diag">
The referenced ISRC supplied within the file was not valid. TrackSale[ParentElement/@Name=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Region/@Name"/><xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="@ISRC"/>, @Sales=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="@Sales"/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales != current()/@Sales and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales != current()/@Sales and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.ISRCDupe.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced ISRC is duplicate within the same Region or Location. TrackSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @Sales=<xsl:value-of select="@Sales"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced ISRC is duplicate within the same Region or Location, using the same @Retailer value. TrackSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @Sales=<xsl:value-of select="@Sales"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales = current()/@Sales and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales = current()/@Sales and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.ISRCDupeAll.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced ISRC is duplicate and has the same sales within the same Region or Location. TrackSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @Sales=<xsl:value-of select="@Sales"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced ISRC is duplicate and has the same sales within the same Region or Location, using the same @Retailer value. . TrackSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @Sales=<xsl:value-of select="@Sales"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales != current()/@Sales and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales != current()/@Sales and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.ISRCDupeNewArtist.diag">
The referenced ISRC is duplicate within the same Region or Location, with different Artist. TrackSale[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @Sales=<xsl:text/><xsl:value-of select="@Sales"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales = current()/@Sales and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackSale[@ISRC = current()/@ISRC and @Sales = current()/@Sales and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.ISRCDupeAllNewArtist.diag">
The referenced ISRC is duplicate and has the same sales within the same Region or Location, with different Artists. TrackSale[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @Sales=<xsl:text/><xsl:value-of select="@Sales"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@Customers &gt; @Sales)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@Customers &gt; @Sales)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="tracksale.invalid.MoreCustThanSales.diag">
The TrackSale has more customers than sales. How?. TrackSale[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @Customers=<xsl:text/><xsl:value-of select="@Customers"/><xsl:text/>, @Sales=<xsl:text/><xsl:value-of select="@Sales"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose><xsl:apply-templates select="*|comment()|processing-instruction()" mode="M6"/></xsl:template><xsl:template match="text()" priority="-1" mode="M6"/><xsl:template match="@*|node()" priority="-2" mode="M6">
		<xsl:apply-templates select="*|comment()|processing-instruction()" mode="M6"/>
	</xsl:template>

<!--PATTERN trackplay.checksTrack Play ISRCs are validated against embedded function-->
<svrl:text xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema">Track Play ISRCs are validated against embedded function</svrl:text>

	<!--RULE -->
<xsl:template match="dsp:TrackPlays" priority="1001" mode="M7"><svrl:fired-rule xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" context="dsp:TrackPlays"/>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackPlays[@Threshold = current()/@Threshold])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackPlays[@Threshold = current()/@Threshold])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplays.invalid.ThresholdDupe.diag">
Duplicate TrackPlays exist within the same file, with the same Threashold value. The grouping of TrackPlays is incorrect.TrackPlayd[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @Threshold=<xsl:text/><xsl:value-of select="@Threshold"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose><xsl:apply-templates select="*|comment()|processing-instruction()" mode="M7"/></xsl:template>

	<!--RULE -->
<xsl:template match="dsp:TrackPlay" priority="1000" mode="M7"><svrl:fired-rule xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" context="dsp:TrackPlay"/>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@ISRC) or vals:ValidateISRC(@ISRC)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@ISRC) or vals:ValidateISRC(@ISRC)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.ISRC.diag">
The referenced ISRC supplied within the file was not valid. TrackPlay[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @TotalPlays=<xsl:text/><xsl:value-of select="@TotalPlays"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays != current()/@TotalPlays and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays != current()/@TotalPlays and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.ISRCDupe.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced ISRC is duplicate within the same Region, Location or TrackPlays. TrackPlay[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @TotalPlays=<xsl:value-of select="@TotalPlays"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced ISRC is duplicate within the same Region, Location or TrackPlays, using the same @Retailer value. TrackPlay[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @TotalPlays=<xsl:value-of select="@TotalPlays"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays = current()/@TotalPlays and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays = current()/@TotalPlays and @Artist = current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.ISRCDupeAll.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced ISRC is duplicate and has the same sales within the same Region, Location or TrackPlays. TrackPlay[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @TotalPlays=<xsl:value-of select="@TotalPlays"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced ISRC is duplicate and has the same sales within the same Region, Location or TrackPlays, using the same @Retailer value. TrackPlay[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @ISRC=<xsl:value-of select="@ISRC"/>, @TotalPlays=<xsl:value-of select="@TotalPlays"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays != current()/@TotalPlays and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays != current()/@TotalPlays and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.ISRCDupeNewArtist.diag">
The referenced ISRC is duplicate within the same Region or Location, with different Artist. TrackPlay[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @TotalPlays=<xsl:text/><xsl:value-of select="@TotalPlays"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays = current()/@TotalPlays and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:TrackPlay[@ISRC = current()/@ISRC and @TotalPlays = current()/@TotalPlays and @Artist != current()/@Artist and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.ISRCDupeAllNewArtist.diag">
The referenced ISRC is duplicate and has the same sales within the same Region or Location, with different Artists. TrackPlay[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @TotalPlays=<xsl:text/><xsl:value-of select="@TotalPlays"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="@TotalPlays = (@PurchasedPlays + @FreePlays + @SubscriptionPlays + @OtherPlays)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="@TotalPlays = (@PurchasedPlays + @FreePlays + @SubscriptionPlays + @OtherPlays)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.TotalPlaysNotEqualToSum.diag">
The TotalPlays quantity does not sum to the other PlayQuantities. TrackPlay[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @TotalPlays=<xsl:text/><xsl:value-of select="@TotalPlays"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@Customers &gt; @TotalPlays)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@Customers &gt; @TotalPlays)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="trackplay.invalid.MoreCustThanPlays.diag">
The TrackSale has more customers than sales. How?. TrackPlay[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @ISRC=<xsl:text/><xsl:value-of select="@ISRC"/><xsl:text/>, @Customers=<xsl:text/><xsl:value-of select="@Customers"/><xsl:text/> @TotalPlays=<xsl:text/><xsl:value-of select="@TotalPlays"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose><xsl:apply-templates select="*|comment()|processing-instruction()" mode="M7"/></xsl:template><xsl:template match="text()" priority="-1" mode="M7"/><xsl:template match="@*|node()" priority="-2" mode="M7">
		<xsl:apply-templates select="*|comment()|processing-instruction()" mode="M7"/>
	</xsl:template>

<!--PATTERN bundlesale.checksBundle Validations-->
<svrl:text xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema">Bundle Validations</svrl:text>

	<!--RULE -->
<xsl:template match="dsp:BundleSale" priority="1000" mode="M8"><svrl:fired-rule xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" context="dsp:BundleSale"/>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@APN) or vals:ValidateBarCode(@APN)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@APN) or vals:ValidateBarCode(@APN)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.APN.diag">
The referenced APN supplied within the file was not valid. BundleSale[ParentElement/@Name=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Region/@Name"/><xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Location/@Name"/>, @APN=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="@APN"/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@GRid) or vals:ValidateBarCode(@GRid)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@GRid) or vals:ValidateBarCode(@GRid)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.GRID.diag">
The referenced GRID supplied within the file was not valid. BundleSale[ParentElement/@Name=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Region/@Name"/><xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Location/@Name"/>, @GRid=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="@GRid"/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@CatalogueNumber) or vals:ValidateCatalogueNumber(@CatalogueNumber)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@CatalogueNumber) or vals:ValidateCatalogueNumber(@CatalogueNumber)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.CatNo.diag">
The referenced Catalogue Number supplied within the file was not valid. Possibly missing or empty. BundleSale[ParentElement/@Name=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Region/@Name"/><xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="ancestor::dsp:Location/@Name"/>, @ProductCatalogueNumber=<xsl:value-of xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" select="@ProductCatalogueNumber"/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="@CatalogueNumber or @APN or @GRid"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="@CatalogueNumber or @APN or @GRid"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.NoIdentifier.diag">
The BundleSale has NO Sales Identifier. BundleSale[ParentElemenet/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @Title=<xsl:text/><xsl:value-of select="@Title"/><xsl:text/>, @Artist=<xsl:text/><xsl:value-of select="@Artist"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@APN = current()/@APN and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@APN = current()/@APN and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.APNDupe.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced APN is duplicate within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @APN=<xsl:value-of select="@APN"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced APN is duplicate within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @APN=<xsl:value-of select="@APN"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@APN = current()/@APN and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@APN = current()/@APN and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.APNDupeAll.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced APN is duplicate and has the same sales within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @APN=<xsl:value-of select="@APN"/>, @Sales=<xsl:value-of select="@Sales"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced APN is duplicate and has the same sales within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @APN=<xsl:value-of select="@APN"/>, @Sales=<xsl:value-of select="@Sales"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@GRid = current()/@GRid and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@GRid = current()/@GRid and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.GRIDDupe.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced GRID is duplicate within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @GRid=<xsl:value-of select="@GRid"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced GRID is duplicate within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @GRid=<xsl:value-of select="@GRid"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@GRid = current()/@GRid and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@GRid = current()/@GRid and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.GRIDDupeAll.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced GRID is duplicate and has the same sales within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @GRid=<xsl:value-of select="@GRid"/>, @Sales=<xsl:value-of select="@Sales"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced GRID is duplicate and has the same sales within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @GRid=<xsl:value-of select="@GRid"/>, @Sales=<xsl:value-of select="@Sales"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@CatalogueNumber = current()/@CatalogueNumber and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@CatalogueNumber = current()/@CatalogueNumber and @Sales != current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.CatNoDupe.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced Catalogue Number is duplicate within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @CatalogueNumber=<xsl:value-of select="@CatalogueNumber"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced Catalogue Number is duplicate within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @CatalogueNumber=<xsl:value-of select="@CatalogueNumber"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(preceding-sibling::dsp:BundleSale[@CatalogueNumber = current()/@CatalogueNumber and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(preceding-sibling::dsp:BundleSale[@CatalogueNumber = current()/@CatalogueNumber and @Sales = current()/@Sales and ((@Retailer = current()/@Retailer) or ( not(@Retailer) and not(current()/@Retailer)))])"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.CatNoDupeAll.diag">
<xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="not(@Retailer)">The referenced Catalogue Number is duplicate and has the same sales within the same Region or Location. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @CatalogueNumber=<xsl:value-of select="@CatalogueNumber"/>, @Sales=<xsl:value-of select="@Sales"/>]</xsl:if><xsl:if xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:rapstype="urn:ARIA-Chart-Common-Type-1.0" xmlns:sch="http://purl.oclc.org/dsdl/schematron" test="@Retailer">The referenced Catalogue Number is duplicate and has the same sales within the same Region or Location, using the same @Retailer value. BundleSale[ParentElement/@Name=<xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:value-of select="ancestor::dsp:Location/@Name"/>, @CatalogueNumber=<xsl:value-of select="@CatalogueNumber"/>, @Sales=<xsl:value-of select="@Sales"/>, @Retailer=<xsl:value-of select="@Retailer"/>]</xsl:if></svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose>

		<!--ASSERT -->
<xsl:choose>
			<xsl:when test="not(@Customers &gt; @Sales)"/>
			<xsl:otherwise>
				<svrl:failed-assert xmlns:schold="http://www.ascc.net/xml/schematron" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:xs="http://www.w3.org/2001/XMLSchema" test="not(@Customers &gt; @Sales)"><xsl:attribute name="location">
						<xsl:apply-templates select="." mode="schematron-get-full-path"/>
					</xsl:attribute><svrl:text/> <svrl:diagnostic-reference diagnostic="bundlesale.invalid.MoreCustThanSales.diag">
The BundleSale has more customers than sales. How?. BundleSale[ParentElement/@Name=<xsl:text/><xsl:value-of select="ancestor::dsp:Region/@Name"/><xsl:text/><xsl:text/><xsl:value-of select="ancestor::dsp:Location/@Name"/><xsl:text/>, @CatalogueNumber=<xsl:text/><xsl:value-of select="@CatalogueNumber"/><xsl:text/>, @APN=<xsl:text/><xsl:value-of select="@APN"/><xsl:text/>, @GRid=<xsl:text/><xsl:value-of select="@GRid"/><xsl:text/>, @Customers=<xsl:text/><xsl:value-of select="@Customers"/><xsl:text/>, @Sales=<xsl:text/><xsl:value-of select="@Sales"/><xsl:text/>]</svrl:diagnostic-reference></svrl:failed-assert>
			</xsl:otherwise>
		</xsl:choose><xsl:apply-templates select="*|comment()|processing-instruction()" mode="M8"/></xsl:template><xsl:template match="text()" priority="-1" mode="M8"/><xsl:template match="@*|node()" priority="-2" mode="M8">
		<xsl:apply-templates select="*|comment()|processing-instruction()" mode="M8"/>
	</xsl:template></xsl:stylesheet>